# -*- coding: utf-8 -*-
"""
Created on Thu Oct 19 2017
Modified on June 5 2018

@author: johana
"""
# Libraries
from definitions import *
from Features import *
from Sample_Camera import * # Simulation
import time

# Global variables
IMA = Image.open("../Data/imagen_IR_"+str(DAY)+".jpg")

MINA = Image.open("../Data/MaskIR_"+str(DAY)+".jpg")
PIX = 25*25
LIM = 255*PIX

# Image capture room 
base =  'samIR.jpg'
filename = base

# Delta definition
if DAY == 30:
    flag = 0
    DX = DXIR30
    DY = DYIR30
else:
    flag = 1
    DX = DXIR31
    DY = DYIR31

# Internal Functions
def IRsensor(rota,COORIR):
    #**with Hardware, execute capture image (tethering)
    angle = ABIR + rota 
    a = capcam(IMA,COORIR,angle,other = flag) # Other 1 select the size para IR image 31 ,other=1
    save_image(a, filename)
    time.sleep(8)
    return a

# Temporal function to indicate mine
def IRmina(rota,COORIR):
    angle = ABIR + rota 
    b = capcam(MINA,COORIR,angle,other = flag)
    acu = np.sum(b)
    hnm = 0
    if acu>LIM:        
        hnm = 1
        save_image(b, 'mina_'+ base)
    return hnm

def IRfeatures(filename):
    # **With Hardware 
    ima = load_image_array(filename) # Read the file of the image captured
    # **Transform the image with a homography matrix -- pendiente
    return imagefeature(ima)

def runIS(fsinA,fsouA,frulA,fsinB,fsouB,frulB):
    local_dir = os.path.dirname(__file__)
    Net_path0 = os.path.join(local_dir, 'Net/'+str(sDAY)+'/net-IR0')
    Net_path1 = os.path.join(local_dir, 'Net/'+str(sDAY)+'/net-IR1')
    Net_path2 = os.path.join(local_dir, 'Net/'+str(sDAY)+'/net-IR2')
    inputnetI, inputnetG, tam = two.IS_Inputs()
    return a_DMS('IR',Net_path0, Net_path1, Net_path2, inputnetI,inputnetG,tam,13,fsinA,fsouA,frulA,fsinB,fsouB,frulB)
    
# Agent definition
two = run_agent('IR', base=ModelAgent)
two.phy_address(2,add2)
# Time to predefine the conecctions among agents
time.sleep(WAITIME)
sam = 0
data = ([])
data1 = ([])
data2 = ([])
data3 = ([])
data4 = ([])
data5 = ([])
data6 = ([])
inicio = time.time()

# Preload logic rules if it is required
if DMS_CUN == 'GFS'  or DMS_CUN == 'ALL' or DMS_NBP == 'GFS':
    fsinA,fsouA,frulA,fsinB,fsouB,frulB = a_DMS_FL_Rules('IR')
else:
    fsinA,fsouA,frulA,fsinB,fsouB,frulB = 0.0,0.0,0.0,0.0,0.0,0.0

while two.readstop() == 0:
    COORIRP = np.genfromtxt('sim_pos.csv',delimiter=',')
    COORIR = np.zeros(2)
    COORIR[0] = COORIRP[0]+DX
    COORIR[1] = COORIRP[1]+DY

    # Sensor capture
    mu, sigma = 0, RANSER
    noise = np.random.normal(mu, sigma, 1)
    act = two.nbp_read() + noise[0]
    a = two.sensor_read(IRsensor,act,COORIR)
    mine = IRmina(act,COORIR)

    # Feature extractor
    two.extract_features(IRfeatures,filename)

    # Intelligent system 
    uncl,uncg,nbp = runIS(fsinA,fsouA,frulA,fsinB,fsouB,frulB)
    two.info([ANGC*nbp[0],uncl[0],act])
    
    #Save data
    delta = time.time()-inicio
    if DMS_CUN == 'ALL':
        tem = np.array([delta,COORIRP[0],COORIRP[1],mine,uncl[0],uncg[0],ANGC*nbp[0],act])
        data1 = np.append(data1,tem)
        tem = np.array([delta,COORIRP[0],COORIRP[1],mine,uncl[0],uncg[1],ANGC*nbp[0],act])
        data2 = np.append(data2,tem)
        tem = np.array([delta,COORIRP[0],COORIRP[1],mine,uncl[0],uncg[2],ANGC*nbp[0],act])
        data3 = np.append(data3,tem)
        tem = np.array([delta,COORIRP[0],COORIRP[1],mine,uncl[0],uncg[3],ANGC*nbp[0],act])
        data4 = np.append(data4,tem)
        tem = np.array([delta,COORIRP[0],COORIRP[1],mine,uncl[0],uncg[4],ANGC*nbp[0],act])
        data5 = np.append(data5,tem)
        tem = np.array([delta,COORIRP[0],COORIRP[1],mine,uncl[0],uncg[5],ANGC*nbp[0],act])
        data6 = np.append(data6,tem)
    else:
        tem = np.array([delta,COORIRP[0],COORIRP[1],mine,uncl[0],uncg[0],ANGC*nbp[0],act])
        data = np.append(data,tem)      
    sam = sam+1

if DMS_CUN == 'ALL':
    data1 = np.reshape(data1, [sam,8])
    np.savetxt('Test/'+str(int(COORIRP[2]))+'_IR_NEAT_'+DMS_NBP+'.csv',data1,delimiter=',')
    data2 = np.reshape(data2, [sam,8])
    np.savetxt('Test/'+str(int(COORIRP[2]))+'_IR_GFS_'+DMS_NBP+'.csv',data2,delimiter=',')
    data3 = np.reshape(data3, [sam,8])
    np.savetxt('Test/'+str(int(COORIRP[2]))+'_IR_MEAN_'+DMS_NBP+'.csv',data3,delimiter=',')
    data4 = np.reshape(data4, [sam,8])
    np.savetxt('Test/'+str(int(COORIRP[2]))+'_IR_MEDIAN_'+DMS_NBP+'.csv',data4,delimiter=',')
    data5 = np.reshape(data5, [sam,8])
    np.savetxt('Test/'+str(int(COORIRP[2]))+'_IR_MAX_'+DMS_NBP+'.csv',data5,delimiter=',')
    data6 = np.reshape(data6, [sam,8])
    np.savetxt('Test/'+str(int(COORIRP[2]))+'_IR_VOTE_'+DMS_NBP+'.csv',data6,delimiter=',')
else:
    data = np.reshape(data, [sam,8])
    np.savetxt('Test/'+str(int(COORSVP[2]))+'_IR_'+DMS_CUN+'_'+DMS_NBP+'.csv',data,delimiter=',')

two.__del__()