# -*- coding: utf-8 -*-
"""
Created on Thu Oct 19 2017
Modified on June 5 2018

@author: johana
"""
# Libraries
from definitions import *
from Features import *
from Sample_Camera import * # Simulation
import time

# Global variables
IMA = Image.open("../Data/imagen_UV_"+str(DAY)+".jpg")

MINA = Image.open("../Data/MaskUV_"+str(DAY)+".jpg")
PIX = 25*25
LIM = 255*PIX

# Image capture room
base =  'samUV.jpg'
filename = base

# Delta definition
if DAY == 30:
    DX = DXUV30
    DY = DYUV30
else:
    DX = DXUV31
    DY = DYUV31

# Internal Functions
def UVsensor(rota,COORUV):
    #**with Hardware, execute capture image (tethering)
    angle = ABUV + rota 
    a = capcam(IMA,COORUV,angle)
    save_image(a, filename)
    time.sleep(11)
    return a

# Temporal function to indicate mine
def UVmina(rota,COORUV):
    angle = ABUV + rota 
    b = capcam(MINA,COORUV,angle)
    acu = np.sum(b)
    hnm = 0
    if acu>LIM:        
        hnm = 1
        save_image(b, 'mina_'+ base)
    return hnm

def UVfeatures(filename):
    # **With Hardware 
    ima = load_image_array(filename) # Read de file of the image captured
    # **Transform the image with a homography matrix -- pendiente
    return imagefeature(ima)

def runIS(fsinA,fsouA,frulA,fsinB,fsouB,frulB):
    local_dir = os.path.dirname(__file__)
    Net_path0 = os.path.join(local_dir, 'Net/'+str(sDAY)+'/net-UV0')
    Net_path1 = os.path.join(local_dir, 'Net/'+str(sDAY)+'/net-UV1')
    Net_path2 = os.path.join(local_dir, 'Net/'+str(sDAY)+'/net-UV2')
    inputnetI, inputnetG, tam = three.IS_Inputs()
    return a_DMS('UV',Net_path0, Net_path1, Net_path2, inputnetI,inputnetG,tam,16,fsinA,fsouA,frulA,fsinB,fsouB,frulB)

# Agent definition
three = run_agent('UV', base=ModelAgent)
three.phy_address(3,add3)
# Time to predefine the conecctions among agents
time.sleep(WAITIME)
sam = 0
data = ([])
data1 = ([])
data2 = ([])
data3 = ([])
data4 = ([])
data5 = ([])
data6 = ([])
inicio = time.time()

# Preload logic rules if it is required
if DMS_CUN == 'GFS' or DMS_CUN == 'ALL' or DMS_NBP == 'GFS':
    fsinA,fsouA,frulA,fsinB,fsouB,frulB = a_DMS_FL_Rules('UV')
else:
    fsinA,fsouA,frulA,fsinB,fsouB,frulB = 0.0,0.0,0.0,0.0,0.0,0.0

while three.readstop() == 0:
    COORUVP = np.genfromtxt('sim_pos.csv',delimiter=',')
    COORUV = np.zeros(2)
    COORUV[0] = COORUVP[0]+DX
    COORUV[1] = COORUVP[1]+DY    
    
    # Sensor capture
    mu, sigma = 0, RANSER
    noise = np.random.normal(mu, sigma, 1)
    act = three.nbp_read() + noise[0]
    a = three.sensor_read(UVsensor,act,COORUV)
    mine = UVmina(act,COORUV)    
    
    # Feature extractor
    three.extract_features(UVfeatures,filename)

    # Intelligent system 
    uncl,uncg,nbp = runIS(fsinA,fsouA,frulA,fsinB,fsouB,frulB)
    three.info([ANGC*nbp[0],uncl[0],act])
    
    #Save data
    delta = time.time()-inicio
    if DMS_CUN == 'ALL':
        tem = np.array([delta,COORUVP[0],COORUVP[1],mine,uncl[0],uncg[0],ANGC*nbp[0],act])
        data1 = np.append(data1,tem)
        tem = np.array([delta,COORUVP[0],COORUVP[1],mine,uncl[0],uncg[1],ANGC*nbp[0],act])
        data2 = np.append(data2,tem)
        tem = np.array([delta,COORUVP[0],COORUVP[1],mine,uncl[0],uncg[2],ANGC*nbp[0],act])
        data3 = np.append(data3,tem)
        tem = np.array([delta,COORUVP[0],COORUVP[1],mine,uncl[0],uncg[3],ANGC*nbp[0],act])
        data4 = np.append(data4,tem)
        tem = np.array([delta,COORUVP[0],COORUVP[1],mine,uncl[0],uncg[4],ANGC*nbp[0],act])
        data5 = np.append(data5,tem)
        tem = np.array([delta,COORUVP[0],COORUVP[1],mine,uncl[0],uncg[5],ANGC*nbp[0],act])
        data6 = np.append(data6,tem)
    else:
        tem = np.array([delta,COORUVP[0],COORUVP[1],mine,uncl[0],uncg[0],ANGC*nbp[0],act])
        data = np.append(data,tem)
    sam = sam+1

if DMS_CUN == 'ALL':
    data1 = np.reshape(data1, [sam,8])
    np.savetxt('Test/'+str(int(COORUVP[2]))+'_UV_NEAT_'+DMS_NBP+'.csv',data1,delimiter=',')
    data2 = np.reshape(data2, [sam,8])
    np.savetxt('Test/'+str(int(COORUVP[2]))+'_UV_GFS_'+DMS_NBP+'.csv',data2,delimiter=',')
    data3 = np.reshape(data3, [sam,8])
    np.savetxt('Test/'+str(int(COORUVP[2]))+'_UV_MEAN_'+DMS_NBP+'.csv',data3,delimiter=',')
    data4 = np.reshape(data4, [sam,8])
    np.savetxt('Test/'+str(int(COORUVP[2]))+'_UV_MEDIAN_'+DMS_NBP+'.csv',data4,delimiter=',')
    data5 = np.reshape(data5, [sam,8])
    np.savetxt('Test/'+str(int(COORUVP[2]))+'_UV_MAX_'+DMS_NBP+'.csv',data5,delimiter=',')
    data6 = np.reshape(data6, [sam,8])
    np.savetxt('Test/'+str(int(COORUVP[2]))+'_UV_VOTE_'+DMS_NBP+'.csv',data6,delimiter=',')
else:
    data = np.reshape(data, [sam,8])
    np.savetxt('Test/'+str(int(COORUVP[2]))+'_UV_'+DMS_CUN+'_'+DMS_NBP+'.csv',data,delimiter=',')
    
three.__del__()