# -*- coding: utf-8 -*-
"""
Created on Thu Oct 19 2017
Modified on June 5 2018

@author: johana
"""
# Libraries
from definitions import *
from Features import *
import time

# Global variables
MAXT = 20 #30

filedata = '/home/johana/Documentos/'+str(DAY)+'Agost/GPR/'
data_mine = np.genfromtxt('../Data/GPR_mine.csv',delimiter=',')
SSIZ = 50

#Temporal function
def angle2indg(ang,it,jt):
    indi = 0
    indj = 0        
    if 90 >= ang > 67.5:
        indi = it-1
        indj = jt+1
    elif 67.5 >= ang > 45:
        indi = it
        indj = jt+1
    elif 45 >= ang > 22.5:
        indi = it+1 
        indj = jt+1
    elif 22.5 >= ang > 0:
        indi = it+1 
        indj = jt 
    elif 0 >= ang > -22.5:
        indi = it
        indj = jt
    elif -22.5 >= ang > -45:
        indi = it+1
        indj = jt-1
    elif -45 >= ang > -67.5:
        indi = it
        indj = jt-1
    elif -67.5 >= ang >=-90:
        indi = it-1 
        indj = jt-1    
    return int(indi), int(indj)

def GPRsensor(rota,it,jt):
    it = int(it)
    jt = int(jt)
    x,y = angle2indg(rota,it,jt)
    x = x % 14
    y = y % 23
    time.sleep(19)
    filename= filedata+'GPR_X'+str(x)+'_Y'+str(x)+'_Z0.dat'
    data_sensor = np.fromfile(filename,dtype=float)
    return data_sensor

# Temporal function to indicate mine
def GPRmine(rota,it,jt):
    it = int(it)
    jt = int(jt)
    x,y = angle2indg(rota,it,jt)
    x = x % 14
    y = y % 23
    hnm = 0
    if data_mine[y,x] == 1:
        hnm = 1
    return hnm

def GPRfeatures(data):
    # **With Hardware 
    gpfea = samfeatures(data,data.size)# Read de file of the image captured
  
    return gpfea
    
def runIS(fsinA,fsouA,frulA,fsinB,fsouB,frulB):
    local_dir = os.path.dirname(__file__)
    Net_path0 = os.path.join(local_dir, 'Net/'+str(sDAY)+'/net-GP0')
    Net_path1 = os.path.join(local_dir, 'Net/'+str(sDAY)+'/net-GP1')
    Net_path2 = os.path.join(local_dir, 'Net/'+str(sDAY)+'/net-GP2')
    inputnetI, inputnetG, tam = five.IS_Inputs()
    return a_DMS('GP',Net_path0, Net_path1, Net_path2, inputnetI,inputnetG,tam,19,fsinA,fsouA,frulA,fsinB,fsouB,frulB)

# Agent definition
five= run_agent('GP', base=ModelAgent)
five.phy_address(5,add5)
five.rscanal(addc)

# Time to predefine the conecctions among agents
time.sleep(WAITIME)
sam = 0
data = ([])
data1 = ([])
data2 = ([])
data3 = ([])
data4 = ([])
data5 = ([])
data6 = ([])
inicio = time.time()

# Preload logic rules if it is required
if DMS_CUN == 'GFS' or DMS_CUN == 'ALL' or DMS_NBP == 'GFS':
    fsinA,fsouA,frulA,fsinB,fsouB,frulB = a_DMS_FL_Rules('GP')
else:
    fsinA,fsouA,frulA,fsinB,fsouB,frulB = 0.0,0.0,0.0,0.0,0.0,0.0

pval = 0
test = 0
pos = np.genfromtxt('sim_pos.csv',delimiter=',')
it = pos[0]/SSIZ
jt = pos[1]/SSIZ

while test < MAXT:
    # Sensor capture
    mu, sigma = 0, RANSER
    noise = np.random.normal(mu, sigma, 1)
    act = five.nbp_read() + noise[0]
    a = five.sensor_read(GPRsensor,act,it,jt)
    mine = GPRmine(act,it,jt)

    # Feature extractor
    five.extract_features(GPRfeatures,a)
    nmv = five.getdatafeature(2)
    grad = abs(nmv - pval)
    pval = nmv
    five.setdatafeature(grad,6)
    #five.log_info('grad: '+str(five.getdatafeature(6))+' pos: '+str(act)+' mean: '+str(pval))

    # Intelligent system 
    uncl,uncg,nbp = runIS(fsinA,fsouA,frulA,fsinB,fsouB,frulB)
    five.info([ANGP*nbp[0],uncl[0],act])
    test=test+1
    
    #Save data
    delta = time.time()-inicio
    if DMS_CUN == 'ALL':
        tem = np.array([delta,pos[0],pos[1],mine,uncl[0],uncg[0],ANGP*nbp[0],act])
        data1 = np.append(data1,tem)
        tem = np.array([delta,pos[0],pos[1],mine,uncl[0],uncg[1],ANGP*nbp[0],act])
        data2 = np.append(data2,tem)
        tem = np.array([delta,pos[0],pos[1],mine,uncl[0],uncg[2],ANGP*nbp[0],act])
        data3 = np.append(data3,tem)
        tem = np.array([delta,pos[0],pos[1],mine,uncl[0],uncg[3],ANGP*nbp[0],act])
        data4 = np.append(data4,tem)
        tem = np.array([delta,pos[0],pos[1],mine,uncl[0],uncg[4],ANGP*nbp[0],act])
        data5 = np.append(data5,tem)
        tem = np.array([delta,pos[0],pos[1],mine,uncl[0],uncg[5],ANGP*nbp[0],act])
        data6 = np.append(data6,tem)
    else:
        tem = np.array([delta,pos[0],pos[1],mine,uncl[0],uncg[0],ANGP*nbp[0],act])
        data = np.append(data,tem)
    sam = sam+1 
    five.log_info(uncl[0])      
        
five.menrs([1,1])
if DMS_CUN == 'ALL':
    data1 = np.reshape(data1, [sam,8])
    np.savetxt('Test/'+str(int(pos[2]))+'_GP_NEAT_'+DMS_NBP+'.csv',data1,delimiter=',')
    data2 = np.reshape(data2, [sam,8])
    np.savetxt('Test/'+str(int(pos[2]))+'_GP_GFS_'+DMS_NBP+'.csv',data2,delimiter=',')
    data3 = np.reshape(data3, [sam,8])
    np.savetxt('Test/'+str(int(pos[2]))+'_GP_MEAN_'+DMS_NBP+'.csv',data3,delimiter=',')
    data4 = np.reshape(data4, [sam,8])
    np.savetxt('Test/'+str(int(pos[2]))+'_GP_MEDIAN_'+DMS_NBP+'.csv',data4,delimiter=',')
    data5 = np.reshape(data5, [sam,8])
    np.savetxt('Test/'+str(int(pos[2]))+'_GP_MAX_'+DMS_NBP+'.csv',data5,delimiter=',')
    data6 = np.reshape(data6, [sam,8])
    np.savetxt('Test/'+str(int(pos[2]))+'_GP_VOTE_'+DMS_NBP+'.csv',data6,delimiter=',')
else:
    data = np.reshape(data, [sam,8])
    np.savetxt('Test/'+str(int(pos[2]))+'_GP_'+DMS_CUN+'_'+DMS_NBP+'.csv',data,delimiter=',')
    
five.__del__()